/* Problem URL: https://codeforces.com/gym/105535/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vi fds(n);
    cin >> fds;

    vvi graph(n);
    nrep(i, 1, n) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    vi ans;
    int total = 0;

    function<bool(int, int)> dfs = [&](int i, int p) {
        fds[i]--;
        total++;

        ans.push_back(i + 1);

        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            if (!dfs(j, i) || fds[i] == 0) {
                return false;
            }
            
            total++;
            fds[i]--;
            ans.push_back(i + 1);

            while (fds[j] > 0) {
                if (fds[i] == 0) {
                    return false;
                }

                ans.push_back(j + 1);
                ans.push_back(i + 1);

                fds[i]--;
                fds[j]--;
                total += 2;
            }
        }

        return true;
    };

    fds[0]++;
    int check = accumulate(all(fds), 0);
    if (!dfs(0, 0) || total != check) {
        cout << "0\n";
        return 0;
    }

    cout << ans;
}
